import greenlet

class scheduler:

  ## markers for calls back into scheduler from tasks
  NEWTASK = 1
  DELETE = 2
  BLOCK = 3
  UNBLOCK = 4
  
  def __init__(self,rate):
    self.tasks = []
    self.schedtask = greenlet.greenlet(self._syscall)
    self.rate = rate

  def start(self,f):
    return self.schedtask.switch(f)

  ## these can be called by tasks

  def setatomic(self,a):
    return greenlet.setatomic(a)
    
  def new_task(self,f):
    c = greenlet.getcurrent()
    c.parent.switch((c,self.NEWTASK,f))

  def yyield(self):
    c = greenlet.getcurrent()
    c.parent.switch(c)

  ## INTERNAL ONLY
    
  def _syscall(self,boot_task):
    t = self._new_task(boot_task)
    greenlet.installtick(self.rate)
    what = t.switch(None)
    while 1:
      if what == None or isinstance(what,greenlet.greenlet):
        ## 2 cases: scheduler switch.  Or exiting
        ## switch from finished child
        ## rotate run queue
        if len(self.tasks):
          p = self.tasks.pop(0)
          self.tasks.append(p)
          what = p.switch(None)
        else:
          break
      else:
        if what[1] == self.DELETE:
          print "DEL",what[0]
          self.tasks.remove(what[0])
          what = None
        elif what[1] == self.NEWTASK:
          print "NT",what
          t = self._new_task(what[2])
          what = what[0].switch(t)
        elif what[1] == self.BLOCK:
          self.tasks.remove(what[0])
          ## maybe put on "waiting" list
          what = None
        elif what[1] == self.UNBLOCK:
          self.tasks.insert(0,what[2])          
          what = what[0].switch(t)          
        else:
          print "SYSCALL",what
          break
    return None
    
  def _new_task(self,f):
    def task_wrap(f,a):
      ## [1] this little dance of jumping into the task
      ## and back out seems to help with some
      ## bug with the recursion_level on task switch
      greenlet.getcurrent().parent.switch(None)
      f(self)
      return (greenlet.getcurrent(),self.DELETE)
    t = greenlet.greenlet(lambda a,f=f: task_wrap(f,a))
    self.tasks.append(t)
    ## see [1] above
    t.switch(greenlet.getcurrent())
    return t

def boot(s):
  print "boot task"
  s.new_task(some_stuffa)
  s.new_task(some_stuffb)
  s.new_task(some_stuffc)
  print "boot task done"
  
def some_stuffa(s):
  print "A"
  for i in range(0,10000):
    if not (i%1000): print "a",i
    #
    # If you uncommment this line then
    # a should finish much later than others
    #s.yyield()

def some_stuffb(s):
  print "B"
  for i in range(0,10000):
    if not(i % 1000): print "b",i

def some_stuffc(s):
  print "C"    
  for i in range(0,10000):
    if not(i % 1000): print "c",i
    
print "about to sched"
scheduler(100).start(boot)
print "done scheduling"



    
